/*  sortcomp.h - define constants & data type for compare funct. */
#define    MAX_KEYS  10 	/* maximum number of keys allowed */

/* sort order constants */
#define    ASCENDING	1
#define    DESCENDING	-1

/* key types */
#define    int16_key	0	/* 16 bit long integer */
#define    char_key	1	/* char field ( uses klength) */
#define    string_key	2	/* char string ( '\0' at end */
#define    int32_key	3	/* 32 bit long integer */
#define    float_key	4	/* floating point data */

typedef struct			/* data to define one key field */
  {
     int   ktype     ;		/* type of field */
     int   kstart    ;		/* starting offset of field */
     int   klength   ;		/* field length */
     int   korder    ;		/* sort order (ascending/desc.) */
  }  SORTKEY ;


/* The sorce file including this header file should	*/
/* declare these variables	*/
/* int	 nkeys ;		*/
/* SORTKEY KEY[MAX_KEY] ; or	*/
/* extern  SORTKEY   keys[] ;	*/
/*				*/



