/*  viedo2.c - basic ROM BIOS calls for Viedo_IO */

#include   "stdio.h"
#include   "cminor.h"
#include   "asmtools.h"
#include   "video.h"

int vid_clr_scn(from_row,thru_row)      /* clear part/all of screen */
  int   from_row , thru_row  ;          /* top and bottom row to clear */
  {
     vid_up(0,from_row,thru_row) ;      /* special case scroll */
  }

int  vid_up(nrows,from_row,thru_row)    /* scroll part/all screen up */
  int   nrows ;                         /* number rows up */
  int   from_row , thru_row ;           /* start and end here */
  {
     REGS  sreg , dreg ;

     sreg.ax = nrows ;
     ( (BYTE_REGS *)&sreg) ->bh = NORMAL_DISPLAY ;
     sreg.cx = from_row << 8 ;          /* ch = from_row , cl=0   */
     sreg.dx = (thru_row <<8) | 79 ;    /* dh = thru_row , dl= 79 */
     vidint(V_SCRLUP,&sreg,&dreg) ;
  }

int  vid_down(nrows,from_row,thru_row)  /* scroll screen down */
  int   nrows ;                         /* number of rows down */
  int   from_row , thru_row ;           /* start and end here */
  {
     REGS  sreg , dreg ;

     sreg.ax = nrows ;
     ( (BYTE_REGS *)&sreg) ->bh = NORMAL_DISPLAY ;
     sreg.cx = from_row << 8 ;          /* ch = from_row , cl = 0  */
     sreg.dx = ( thru_row << 8) | 79 ;  /* dh = thru_row , dl = 79 */
     vidint(V_SCRLDOWN,&sreg,&dreg) ;
  }

int vid_blank(n,a)                      /* write n blanks */
  int   n  ;                            /* number blanks to write */
  char  a  ;                            /* use this attribute */
  {
     REGS  sreg , dreg ;

     sreg.bx = a & 0xff ;   sreg.ax = ' ' ;  sreg.cx = n  ;
     vidint(V_WCA,&sreg,&dreg) ;
  }
